<?php

namespace App\Http\Controllers\Admin\Invoice;

use App\Traits\InvoiceTrait;
use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use Illuminate\Support\Facades\Auth;


class InvoiceController extends Controller
{
    //private $userRepo;
    use InvoiceTrait;

    public function __construct()
    {
        //$this->userRepo = new UserRepo();
    }

    public function index()
    {
        $info = ['title' => 'Invoice List'];

        return view('admin.invoice.index', compact('info'));
    }

    public function getInvoiceData(Request $request)
    {
        $input = $request->all();

        return $this->getInvoice($request);
    }

    public function create()
    {
        $info = ['title' => 'Create Invoice'];
        return view('admin.invoice.add', compact('info'));
    }

    public function test()
    {
        $info = ['title' => 'Create Invoice'];
        return view('admin.invoice.email.pay_invoice_link_email', compact('info'));
    }

    public function sendInvoice(Request $request)
    {
        return $this->sendSaveInvoice($request, 1);
    }

    public function saveInvoice(Request $request)
    {
        return $this->sendSaveInvoice($request, 0);
    }

    public function sendAgain(Request $request)
    {
        return $this->sendEmailAgain($request);
    }

    public function destroy($id)
    {
        return $this->deleteInvoice($id);
    }

    public function edit($id)
    {
        $info = ['title' => 'Edit Invoice'];
        $row = $this->getInvoiceById($id);
        return view('admin.invoice.edit', compact('info', 'row'));
    }

    public function update(Request $request, $id)
    {
        $input = $request->all();

        return $this->updateInvoice($id, $input);
    }

    public function priceQuote(Request $request)
    {
        $input = $request->all();
        //dd($input);
        $this->changeStatus($input);

        $json = [
            'type' => 'success',
            'redirect' => '',
            'message' => 'Successfully saved.'
        ];

        return response()->json($json);
    }

    public function LandPay(Request $request)
    {
        $info = ['title' => 'Land Pay'];
        $input = $request->all();
        $check = $this->checkTokenValid($input);
        if($check != 5){
            $type = "error";
            $message = "Invalid payment link.";
            if($check == 3){
                $message = "Your link has expired.";
            }

            if($check == 4){
                $type = "success";
                $message = "You have already settled this invoice.";
            }
            return view('admin.invoice.land_pay_error', compact('info', 'message', 'type'));
        }


        $invoiceInfo = $this->getInvoiceInfo($input['pay_token']);
        return view('admin.invoice.land_pay', compact('info', 'invoiceInfo'));
    }

    public function notify(Request $request){
        $info = ['title' => 'Land Pay'];
        $input = $request->all();

        $type = "success";
        $message = "You have already settled this invoice.";
        $isTrn = false;
        if(isset($input['trn_id'])){
            $message = "Transaction ID is ".$input['trn_id'];
            $isTrn = true;
        }

        return view('admin.invoice.land_pay_error', compact('info', 'message', 'type', 'isTrn'));
    }

    public function settingInfo(Request $request)
    {
        return $this->saveSetting($request);
    }

    public function sendPay(Request $request)
    {
        return $this->callIPG($request);
    }

    public function getPaymentResponse(Request $request)
    {
        return $this->decodePayInfo($request);
    }
}
