<?php

namespace App\Mail;

use Illuminate\Bus\Queueable;
use Illuminate\Mail\Mailable;
use Illuminate\Queue\SerializesModels;
use Illuminate\Contracts\Queue\ShouldQueue;

class SendMail extends Mailable
{
    use Queueable, SerializesModels;

    public $subject;
    public $content;
    public $attach;
    public $fromAddress;
    public $fromName;
    public $type;

    /**
     * Create a new message instance.
     *
     * @return void
     */
    public function __construct($content, $subject, $attach = "", $type = "", $fromAddress = "", $fromName = "")
    {
        $this->content = $content;
        $this->subject = $subject;
        $this->attach = $attach;
        $this->fromAddress = $fromAddress;
        $this->fromName = $fromName;
        $this->type = $type;
    }

    /**
     * Build the message.
     *
     * @return $this
     */
    public function build()
    {
        $this->fromAddress = $this->fromAddress == "" ? "support@agcimport.com" : $this->fromAddress;
        $this->fromName = $this->fromName == "" ? "Support Team" : $this->fromName;

        $mail = $this->view('import.emails.default_email')
            ->from($this->fromAddress, $this->fromName)
            //->cc($address, $name)


            //->replyTo($address, $name)
            ->subject($this->subject);
        //->with([ 'message' => $this->data['message'] ]);

        if ($this->attach != "") {
            $mail->attach($this->attach);
        }

//        if($this->type != "" && ($this->type == 1 || $this->type == 2 || $this->type == 3)){
//            $mail->bcc(config('app.feedback_lcd'), '');
//        }
    }
}
