<?php

namespace App\Repositories;

use App\Models\SecurityLayer;
use DB;
use Validator;
use Illuminate\Validation\Rule;



class CommonRepo
{
    public static function commonStore($model, $dataArray)
    {
        return $model::create($dataArray);
    }

    public function commonTruncate($model)
    {
        $model::query()->truncate();
    }

    public static function commonUpdate($model, $whereArray, $updateArray)
    {
        return $model::where($whereArray)->update($updateArray);
    }

    public static function commonInsert($model, $dataArray)
    {
        return $model::insertGetId($dataArray);
    }

    public static function checkExist($table, $field, $value, $edit)
    {
        if ($edit) {//dd('asdf');
            $rules = [
                'email' => [Rule::unique($table)->ignore($edit, 'id')->whereNull('deleted_at')]
            ];

        } else {
            $rules = [
                //'email' => 'required|email|unique:users',
                'email' => [Rule::unique($table)->whereNull('deleted_at')]
            ];
        }

        $input[$field] = $value;//dd($rules);
        $validator = Validator::make($input, $rules);

        if ($validator->fails()) {
            return false;
        }

        return true;
    }

    public static function checkExistNotDel($table, $field, $value, $edit)
    {
        if ($edit) {//dd('asdf');
            $rules = [
                $field => [Rule::unique($table)->ignore($edit, 'id')]
            ];

        } else {
            $rules = [
                //'email' => 'required|email|unique:users',
                $field => [Rule::unique($table)]
            ];
        }

        $input[$field] = $value;//dd($rules);
        $validator = Validator::make($input, $rules);

        if ($validator->fails()) {
            return false;
        }

        return true;
    }

    public static function commonDelete($model, $whereArray)
    {
        return $model::where($whereArray)->delete();
    }

    public static function getLayers()
    {
        return SecurityLayer::all();
    }

    public static function getActiveLayers()
    {
        return SecurityLayer::where('status', 1);
    }

    public static function getAllById($model, $id)
    {
        $result = $model::where('id', $id)->get();
        return $result[0];
    }
}