<?php

namespace App\Repositories;

use App\Models\LoginCode;
use App\Models\PasswordReset;
use App\User;
use DB;


class UserRepo
{
    public function getAllUsers($input)
    {
        if (isset($input['order'][0]['column']) && $input['order'][0]['column'] == 5) {
            return User::orderBy('status', $input['order'][0]['dir'])->get();
        }

        if (isset($input['order'][0]['column']) && $input['order'][0]['column'] == 6) {
            return User::orderBy('is_logged_in', $input['order'][0]['dir'])->get();
        }

        return User::where('is_deleted', 0)->get();
    }

    public function checkUserByUserName($email)
    {
        return User::select('id', 'password', 'pin_number', 'ip_address', 'mac_address', 'name', 'status')
            ->where('email', $email)
            ->get();
    }

    public function addLoginCode($data)
    {
        CommonRepo::commonStore('App\Models\LoginCode', $data);
    }


    public function getLoginCodeDataByUser($userId, $time, $loginCode)
    {
        return LoginCode::where('user_id', $userId)
            ->where('login_code', $loginCode)
            ->where('status', 1)
            ->where('created_at', '>', $time)
            ->get();
    }

    public function getResetDataByUser($token)
    {
        return PasswordReset::where('token', $token)
            ->get();
    }

    public function checkEmailValid($email)
    {
        return User::select('id', 'name')
            ->where('email', $email)
            ->where('status', 1)
            ->where('is_deleted', 0)
            ->get();
    }



}