<?php

namespace App\Traits\Api;

use App\Models\AcToken;
use GuzzleHttp\Exception\GuzzleException;
use GuzzleHttp\Client;
use Illuminate\Support\Facades\Log;


//use Yajra\DataTables\Contracts\DataTable;

trait CommonApiTrait
{
    public function getAccessToken()
    {
        try {

            $client = new Client([
                'base_uri' => env('API_BASE_URL'),
                'headers' => [
                    'Accept' => 'application/json',
                    'Content-Type' => 'application/json',
                ],
            ]);

            $dataArray = [
                'form_params' => [
                    'grant_type' => 'client_credentials',
                    'client_id' => env('API_CLIENT_ID'),
                    'client_secret' => env('API_CLIENT_SECRET'),
                ]
            ];

            $response = $client->request("POST", 'oauth/token', $dataArray);

            return $response->getBody()->getContents();

        } catch (\Exception $exception) {
            dd($exception->getMessage());
            Log::info($exception->getMessage());
        }
    }

    protected function commonCall($token, $method, $url, $data)
    {
        ini_set('max_execution_time', 0);
        try {
            $dataArray = [
                'headers' => [
                    'Authorization' => 'Bearer ' . $token,
                    'Accept' => 'application/json',
                    //'Content-Type' => 'application/json',
                ],
                'form_params' => [$data]
            ];

            $client = new Client();
            $response = $client->request($method, $url, $dataArray);

            $response = $response->getBody()->getContents();

            return json_decode($response, true);

        } catch (\Exception $exception) {
            dd($exception->getMessage());
            Log::info($exception->getMessage());

            return false;
        }
    }

    protected function getTokenFromDb()
    {
        return AcToken::first();
    }

}