<?php

namespace App\Traits;

use App\Helpers\FormatHelper;
use App\Mail\SendMail;
use App\Repositories\CommonRepo;
use App\User;
use Carbon\Carbon;
use GuzzleHttp\Psr7\Request;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Mail;
use Validator;
use Illuminate\Support\Facades\Hash;


//use Yajra\DataTables\Contracts\DataTable;

trait CommonTrait
{
//    public function sendToFriend()
//    {
//        $email = new \SendGrid\Mail\Mail();
//        $email->setFrom("test@example.com", "Example User");
//        $email->setSubject("Sending with SendGrid is Fun");
//        $email->addTo("pasanmherath@gmail.com", "Example User");
//
//        $email->addContent(
//            "text/plain", "and easy to do anywhere, even with PHP"
//        );
//
//        $email->addContent(
//            "text/html", "<strong>and easy to do anywhere, even with PHP</strong>"
//        );
//
//        $sendgrid = new \SendGrid('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');
//        try {
//            $response = $sendgrid->send($email);
//            print $response->statusCode() . "\n";
//            print_r($response->headers());
//            print $response->body() . "\n";
//        } catch (Exception $e) {
//            echo 'Caught exception: ', $e->getMessage(), "\n";
//        }
//    }

    public function sendCommonMail($to, $content, $subject, $message)
    {
        $email = new \SendGrid\Mail\Mail();
        $email->setFrom("onlinepayments@authenticitiessrilanka.com", "Support Team");
        $email->setSubject($subject);
        $email->addTo($to, "");
        $email->addContent("text/html", $content->render());

        $sendgrid = new \SendGrid(env('SEND_GRID_KEY'));

        try {

            $sendgrid->send($email);

            //Mail::to($to)->send(new SendMail($data, $subject));
            $json = [
                'type' => 'success',
                'redirect' => '',
                'step' => 3,
                'layers' => FormatHelper::getLayers(),
                'message' => $message
            ];
            return $json;

        } catch (\Exception $e) {
            dd($e);
            $json = [
                'type' => 'error',
                'redirect' => 'reload',
                'step' => 0,
                'message' => 'Sorry! Please try again.'
            ];

            return $json;
        }
    }

    public function sendCommonMailInvoice($to, $content, $subject, $message, $fromEmail)
    {
        $email = new \SendGrid\Mail\Mail();
        $fromEmail = $fromEmail!=""?$fromEmail:"onlinepayments@authenticitiessrilanka.com";
        $email->setFrom($fromEmail, "Support Team");
        $email->setSubject($subject);
        $email->addTo($to, "");
        $email->addContent("text/html", $content->render());

        $sendgrid = new \SendGrid(env('SEND_GRID_KEY'));

        try {

            $sendgrid->send($email);

            //Mail::to($to)->send(new SendMail($data, $subject));
            $json = [
                'type' => 'success',
                'redirect' => '',
                'step' => 3,
                'layers' => FormatHelper::getLayers(),
                'message' => $message
            ];
            return $json;

        } catch (\Exception $e) {
            dd($e);
            $json = [
                'type' => 'error',
                'redirect' => 'reload',
                'step' => 0,
                'message' => 'Sorry! Please try again.'
            ];

            return $json;
        }
    }

}