<?php
namespace App\Traits;

use App\Models\HouseRoom;
use App\Repositories\AmenityRepo;
use App\Repositories\CommonRepo;
use Datatables;
use App\Models\House;

trait FilterTrait
{
    public function getCustomFilterData($data, $input)
    {
        //dd($input);
        if ($input['room_type'] == "") {
            return Datatables::of($data)
                ->make(true);
        }

        if ($input['room_type'] == 1) {
            return Datatables::of($data)
                ->addColumn('action', function ($data) {
                    return '<a href="' . url('filter/' . $data->id . '/view') . '" class="btn btn-sm btn-info"><i class="la la-eye"></i></a>
                <button data-fhouse="'.$data->id.'" id="tick_btn_'.$data->id.'" type="button" class="btn btn-sm btn-success full-select"><i class="la la-check"></i></button>';
                })
                ->addColumn('h_room_no', function (House $house) {
                    return $house->rooms->map(function ($room) {
                        return $room->room_no;
                    })->implode(' , ');
                })
                ->editColumn('house_number', function ($data) {
                    return $data->house_number . ' <span style="font-style: oblique;"> ( price = ' . number_format($data->full_price, 2, '.', ',') . ' ) </span> ';
                })
                ->make(true);
        }

        if ($input['room_type'] == 2) {
            return Datatables::of($data)
                ->addColumn('action', function ($data) {
                    return '<a href="' . url('filter/' . $data->id . '/view') . '" class="btn btn-sm btn-info"><i class="la la-eye"></i></a>
                <button data-fhouse="'.$data->id.'" id="tick_btn_'.$data->id.'" type="button" class="btn btn-sm btn-success anex-select"><i class="la la-check"></i></button>';
                })
                ->addColumn('h_room_no', function (House $house) {
                    return $house->rooms->map(function ($room) {
                        if ($room->room_type == 1) {
                            return $room->room_no . ' <span data-anroom="'.$room->id.'" style="font-style: oblique;"> ( price = ' . number_format($room->room_price, 2, '.', ',') . ' ) </span> ';
                        }
                    })->implode(' , ');
                })
                ->editColumn('house_number', function ($data) {
                    return $data->house_number . ' <span style="font-style: oblique;"> ( price = ' . number_format($data->full_price, 2, '.', ',') . ' ) </span> ';
                })
                ->make(true);
        }

        if ($input['room_type'] == 3) {
            return Datatables::of($data)
                ->addColumn('action', function ($data) {
                    return '<a href="' . url('filter/' . $data->id . '/view') . '" class="btn btn-sm btn-info"><i class="la la-eye"></i></a>
                <a href="#edit-' . $data->id . '" class="btn btn-sm btn-success"><i class="la la-paper-plane"></i></a>';
                })
                ->addColumn('h_room_no', function (House $house) {
                    return $house->rooms->map(function ($room) {
                            return $room->room_no . ' <span style="font-style: oblique;"> ( price = ' . number_format($room->room_price, 2, '.', ',') . ' ) </span> ';

                    })->implode(' , ');
                })
                ->editColumn('house_number', function ($data) {
                    return $data->house_number . ' <span style="font-style: oblique;"> ( price = ' . number_format($data->full_price, 2, '.', ',') . ' ) </span> ';
                })
                ->make(true);
        }

    }

}