<?php

namespace App\Traits;

use App\Helpers\FormatHelper;
use App\Models\SystemSetting;
use App\Repositories\CommonRepo;
use App\User;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Hash;
use Illuminate\Validation\Rule;
use PhpOffice\PhpSpreadsheet\Calculation\Token\Stack;
use Spatie\Permission\Models\Role;
use Validator;
use DataTables;


//use Yajra\DataTables\Contracts\DataTable;

trait SettingTrait
{
    protected function changeStatus($input)
    {
        $model = 'App\Models\SecurityLayer';
        $whereArray = ['id' => $input['id']];
        $updateArray = ['status' => $input['status']];
        CommonRepo::commonUpdate($model, $whereArray, $updateArray);
    }

    protected function saveSetting($request)
    {
        $input = $request->all();

        $validator = $this->settingValidation($input);
        /*if ($validator->fails()) {
            $json = [
                'type' => 'error',
                'redirect' => '',
                'message' => $validator->messages()->toArray()
            ];

            return response()->json($json);
        }*/

        SystemSetting::query()->truncate();
        $model = 'App\Models\SystemSetting';
        CommonRepo::commonStore($model, $input);

        $json = [
            'type' => 'success',
            'redirect' => url('main_settings'),
            'message' => 'Successfully setting information saved.',
        ];

        return response()->json($json);
    }

    private function settingValidation($input)
    {
        $rules = [
            'order_req_company_name' => 'required',
            //'mac_address' => 'required'
        ];

        return Validator::make($input, $rules);
    }

    protected function getSetting()
    {
        return SystemSetting::first();
    }

}