$(document).ready(function () {

    $('.image-form-save').on('click', function (e) {
        e.preventDefault();

        var formName = $(this).data('formname');
        var url = $("." + formName).attr('action');
        var postType = $('.image-form-save').data('posttype');

        submitForm(url, postType, formName);
    });

    $('.decimal_numbers_only').on('keypress', function (evt) {
        evt = (evt) ? evt : window.event;
        var charCode = (evt.which) ? evt.which : evt.keyCode;
        if ((charCode > 33 && (charCode < 48 || charCode > 57)) && charCode != 46) {
            return false;
        } else {
            return true;
        }
    });

    $('.numbers_only').on('keypress', function (evt) {
        evt = (evt) ? evt : window.event;
        var charCode = (evt.which) ? evt.which : evt.keyCode;
        if ((charCode > 33 && (charCode < 48 || charCode > 57))) {
            return false;
        } else {
            return true;
        }
    })

});

function submitForm(url, postType, formName) {

    if ($("." + formName).validationEngine('validate')) {

        $.ajaxSetup({
            headers: {
                'X-CSRF-TOKEN': $('meta[name="csrf-token"]').attr('content')
            }
        });

        var btnText = $('.image-form-save').html();
        $('.image-form-save').css("pointer-events", "none");
        $('.image-form-save').html('Please wait...');

        if (typeof CKEDITOR != "undefined") {
            for (instance in CKEDITOR.instances) {
                CKEDITOR.instances[instance].updateElement();
            }
        }
        var formData = new FormData($("." + formName)[0]);

        setTimeout(function () {
            $.ajax({
                dataType: 'json',
                url: url,
                type: postType,
                data: formData,
                async: false,
                cache: false,
                contentType: false,
                processData: false,
                beforeSend: function () {
                    Pace.restart();
                },
                success: function (response) {
                    //alert(response);
                    //console.log(response);
                    $('.image-form-save').css("pointer-events", "auto");
                    $('.image-form-save').html(btnText);
                    if (response.type != 'success') {
                        var msg = "";

                        if (typeof response.message === 'string') {
                            msg = response.message;
                        } else {
                            $.each(response.message, function (index, value) {
                                msg += value + '<br/>';
                            });
                        }

                        notification(msg, response.type, '');

                    } else {
                        console.log(response.message);
                        notification(response.message, response.type, response.redirect);
                    }
                    //hideNotification();
                },
                error: function (xhr, status, error) {
                    var err = xhr.responseText;
                    console.log(err);
                    alert("error in ajax form submission");
                }
            });
        }, 100);

        // }else {
        //alert('fail');
    }
}

function submitFormQuot(url, postType, formName, thisObj) {

    $.ajaxSetup({
        headers: {
            'X-CSRF-TOKEN': $('meta[name="csrf-token"]').attr('content')
        }
    });

    var btnText = thisObj.html();
    thisObj.css("pointer-events", "none");
    thisObj.html('Please wait...');

    if (typeof CKEDITOR != "undefined") {
        for (instance in CKEDITOR.instances) {
            CKEDITOR.instances[instance].updateElement();
        }
    }
    var formData = new FormData($("." + formName)[0]);

    setTimeout(function () {
        $.ajax({
            dataType: 'json',
            url: url,
            type: postType,
            data: formData,
            async: false,
            cache: false,
            contentType: false,
            processData: false,
            beforeSend: function () {
                Pace.restart();
            },
            success: function (response) {
                //alert(response);
                //console.log(response);
                thisObj.css("pointer-events", "auto");
                thisObj.html(btnText);
                if (response.type != 'success') {
                    var msg = "";

                    if (typeof response.message === 'string') {
                        msg = response.message;
                    } else {
                        $.each(response.message, function (index, value) {
                            msg += value + '<br/>';
                        });
                    }

                    notification(msg, response.type, '');

                } else {
                    console.log(response.message);
                    notification(response.message, response.type, response.redirect);
                }
                //hideNotification();
            },
            error: function (xhr, status, error) {
                var err = xhr.responseText;
                console.log(err);
                alert("error in ajax form submission");
            }
        });
    }, 100);

    // }else {
    //alert('fail');

}

function ajax_post(url, data, type) {
    console.log(data);
    $.ajaxSetup({
        headers: {
            'X-CSRF-TOKEN': $('meta[name="csrf-token"]').attr('content')
        }
    });

    return $.ajax({
        'dataType': 'json',
        'type': type,
        'url': url,
        async: false,
        'data': data,
        beforeSend: function () {
            //Pace.restart();
        },
    });
}

function notification(msg, type, redirect) {
    $('#msg_span').html('');
    if (msg != "") {
        if (type == 'success') {
            toastr.success(msg, '');
        } else {
            toastr.error(msg, '');
        }
    }

    if (redirect === 'reload') {
        setTimeout(function () {
            location.reload(true);
        }, 3000);
    } else if (redirect === '') {
        // do something here
    } else if (redirect === 'reset') {
        $('.image-form').trigger("reset");
        $(".chosen-select").trigger("chosen:updated");
        $(".select2").val(null).trigger("change");
    } else {
        setTimeout(function () {
            window.location = redirect;
        }, 3000);
    }
}

function checkExist(url, field, thisOb) {

    var data = {
        field: field,
        value: thisOb.val()
    };

    $('.image-form-save').css("pointer-events", "none");
    $('.image-form-save').attr('value', 'Please wait...');

    var post = ajax_post(url, data, 'GET');
    return post.done(function (response) {
        $('.image-form-save').css("pointer-events", "auto");
        $('.image-form-save').attr('value', 'Submit');
        if (response.type != 'success') {
            notification(response.message, response.type, '');
            thisOb.val('');
        }

    });

}

function checkValid(url) {

    var post = ajax_post(url, '', 'POST');
    post.done(function (response) {
        notification(response.message, response.type, response.redirect);
    });
}

function submitFormSaveOnly(url, postType, formName) {

    if ($("." + formName).validationEngine('validate')) {

        $.ajaxSetup({
            headers: {
                'X-CSRF-TOKEN': $('meta[name="csrf-token"]').attr('content')
            }
        });

        var btnText = $('.image-form-save-only').html();
        $('.image-form-save-only').css("pointer-events", "none");
        $('.image-form-save-only').html('Please wait...');

        if (typeof CKEDITOR != "undefined") {
            for (instance in CKEDITOR.instances) {
                CKEDITOR.instances[instance].updateElement();
            }
        }
        var formData = new FormData($("." + formName)[0]);

        setTimeout(function () {
            $.ajax({
                dataType: 'json',
                url: url,
                type: postType,
                data: formData,
                async: false,
                cache: false,
                contentType: false,
                processData: false,
                beforeSend: function () {
                    Pace.restart();
                },
                success: function (response) {
                    //alert(response);
                    //console.log(response);
                    $('.image-form-save-only').css("pointer-events", "auto");
                    $('.image-form-save-only').html(btnText);
                    if (response.type != 'success') {
                        var msg = "";

                        if (typeof response.message === 'string') {
                            msg = response.message;
                        } else {
                            $.each(response.message, function (index, value) {
                                msg += value + '<br/>';
                            });
                        }

                        notification(msg, response.type, '');

                    } else {
                        console.log(response.message);
                        notification(response.message, response.type, response.redirect);
                    }
                    //hideNotification();
                },
                error: function (xhr, status, error) {
                    var err = xhr.responseText;
                    console.log(err);
                    alert("error in ajax form submission");
                }
            });
        }, 100);

        // }else {
        //alert('fail');
    }
}
