@extends('layouts.app')

@section('content')
    <style>
        .dataTable {
            width: 100% !important;
        }

        table.dataTable thead .sorting_asc:after {
            content: '';
            color: rgb(50, 50, 55);
            opacity: 1;
        }

        table.dataTable thead .sorting:after {

            content: "";
            color: rgb(50, 50, 55);
            opacity: 1;
        }

        table.dataTable thead .sorting_desc:after {
            content: "";
            color: rgb(50, 50, 55);
            opacity: 1;
        }

        .form-control {
            border: 1px solid #c5c5c5 !important;
        }
    </style>


    <div class="row">
        <div class="col-lg-12">

            <div class="card">
                <div class="card-header">
                    <h4 class="card-title" id="heading-buttons1">Manage Role Permissions</h4>
                    <div class="heading-elements">
                        <a href="{{url('create_role_permission')}}"
                           class="btn btn-info btn-min-width btn-glow btn-cons pull-right">Add</a>
                    </div>
                </div>
                <div class="card-content">
                    <div class="card-body user-list">
                        <table class="table table-bordered table-hover demo-table-search table-responsive-block" id="posts-table">
                            <thead>
                            <tr>
                                <th>Role</th>
                                <th>Permissions</th>
                                <th class="nosort" style="width: 30%">Action</th>
                            </tr>
                            </thead>
                            <tbody>

                            @foreach ($roles as $role)
                                <tr>

                                    <td>{{ $role->name }}</td>

                                    <td>{{  $role->permissions()->pluck('name')->implode(' , ') }}</td>{{-- Retrieve array of permissions associated to a role and convert to string --}}
                                    <td>

                                        <a href="{{url('roles/'.$role->id.'/edit')}}" class="btn btn-outline-info"><i class="la la-pencil"></i></a>
                                        {{--<button class="btn btn-outline-danger delete-btn" data-delete_url="{{url('delete/'. $role->id)}}"><i class="la la-trash-o"></i></button>--}}

                                        {{--<a href="{{ URL::to('roles/'.$role->id.'/edit') }}" class="btn btn-info pull-left"--}}
                                        {{--style="margin-right: 3px;">Edit</a>--}}

                                        {{--{!! Form::open(['method' => 'DELETE', 'route' => ['roles.destroy', $role->id] ]) !!}--}}
                                        {{--{!! Form::submit('Delete', ['class' => 'btn btn-danger']) !!}--}}
                                        {{--{!! Form::close() !!}--}}

                                    </td>
                                </tr>
                            @endforeach

                            </tbody>
                        </table>
                    </div>
                </div>
            </div>

        </div>
    </div>

@endsection

@section('script')


    {{--<script src="{{ asset('assets/js/datatables.js')}}" type="text/javascript"></script>--}}

    <script>
        $(document).ready(function () {

        });
    </script>

@endsection