@extends('layouts.app')

@section('styles')

    <link rel="stylesheet" type="text/css" href="{{ asset('modern/app-assets/vendors/css/forms/icheck/icheck.css')}}">
    <link rel="stylesheet" type="text/css" href="{{ asset('modern/app-assets/vendors/css/forms/icheck/custom.css')}}">
    <style>

    </style>
@endsection

@section('content')

    @hasanyrole('Super Admin')
    <div class="row">
        <div class="col-lg-12">

            <div class="card">
                <div class="card-header separator">
                    <h4 class="card-title" id="heading-buttons1">Security Layers</h4>
                    <a class="heading-elements-toggle"><i class="la la-ellipsis-v font-medium-3"></i></a>
                    <div class="heading-elements">

                    </div>
                </div>
                <div class="card-content">
                    <div class="card-body skin skin-flat">
                        <form role="form" action="{{url('user')}}" method="POST"
                              class="add form-validations">
                            <div class="row">
                                <div class="col-md-12">
                                    <div class="table-responsive">
                                        <table class="table table-bordered">
                                            {{--<thead></thead>--}}
                                            {{--<tbody>--}}
                                            <?php $layers = FormatHelper::getLayers();?>
                                            <tr class="top-border">
                                                <td class="no-r-border">
                                                    <label for="name" class="control-label">SSL
                                                        Verification</label>
                                                </td>
                                                <td>
                                                    <input type="checkbox" class="sec-switch" data-id="1"
                                                    <?php echo $layers['ssl'] == 1 ? "checked" : "";?>
                                                    />
                                                </td>

                                                <td class="no-r-border">
                                                    <label for="name" class="control-label">Dynamic Code
                                                        Verification</label>
                                                </td>
                                                <td>
                                                    <input type="checkbox" class="sec-switch" data-id="5"
                                                           <?php echo $layers['dynamic_code'] == 1 ? "checked" : "";?>
                                                           data-init-plugin="switchery"/>
                                                </td>
                                                <td class="no-r-border">
                                                    <label for="name" class="control-label">Captcha
                                                        Verification</label>
                                                </td>
                                                <td>
                                                    <input type="checkbox" class="sec-switch" data-id="6"
                                                           <?php echo $layers['captcha'] == 1 ? "checked" : "";?>
                                                           data-init-plugin="switchery"/>
                                                </td>
                                            </tr>
                                            <tr class="top-border">
                                                <td class="no-r-border">
                                                    <label for="name" class="control-label">Pin Number
                                                        Verification</label>
                                                </td>
                                                <td>
                                                    <input type="checkbox" class="sec-switch" data-id="4"
                                                           data-init-plugin="switchery" <?php echo $layers['pin'] == 1 ? "checked" : "";?> />
                                                </td>
                                                <td class="no-r-border">
                                                    <label for="name" class="control-label">Mac Address
                                                        Verification</label>
                                                </td>
                                                <td>
                                                    <input type="checkbox" class="sec-switch" data-id="2"
                                                           <?php echo $layers['mac'] == 1 ? "checked" : "";?>
                                                           data-init-plugin="switchery"/>
                                                </td>
                                                <td class="no-r-border">
                                                    <label for="name" class="control-label">Ip Address
                                                        Verification</label>
                                                </td>
                                                <td>
                                                    <input type="checkbox" class="sec-switch" data-id="3"
                                                           data-init-plugin="switchery"
                                                    <?php echo $layers['ip_address'] == 1 ? "checked" : "";?>
                                                    />
                                                </td>
                                            </tr>

                                            {{--</tbody>--}}

                                        </table>
                                    </div>
                                </div>
                            </div>

                        </form>
                    </div>
                </div>
            </div>

        </div>
    </div>
    @endhasanyrole

    @hasanyrole('Super Admin|Management')

    <div class="row">

        <div class="col-lg-12">

            <div class="card">
                <div class="card-header separator">
                    <h4 class="card-title" id="heading-buttons1">Common Settings</h4>
                    <a class="heading-elements-toggle"><i class="la la-ellipsis-v font-medium-3"></i></a>
                    <div class="heading-elements">

                    </div>
                </div>
                <div class="card-content">
                    <div class="card-body">
                        <form role="form" action="{{url('price_quote')}}" method="POST"
                              class="setting_add form-validations">
                            <div class="row">
                                <div class="col-md-5">
                                    <div class="form-group form-group-style">
                                        <label>Token Exp date limit<span class="red">*</span></label>
                                        <input type="number" class="form-control validate[required]"
                                               value="{{$setting->token_exp_date_count}}"
                                               name="token_exp_date_count">
                                    </div>
                                </div>
                                
                                <div class="col-md-3">
                                    <button style="margin-top: 10px" class="btn btn-info btn-cons image-form-save" type="button"
                                            data-formname="setting_add"
                                            data-posttype="POST">
                                        <i class="la la-check-square-o"></i> Save
                                    </button>
                                </div>
                            </div>
                        </form>
                    </div>
                </div>
            </div>

        </div>
    </div>

    
    @endhasanyrole

@endsection

@section('script')

    <script src="{{ asset('modern/app-assets/vendors/js/forms/icheck/icheck.min.js')}}"></script>
    <script src="{{ asset('modern/app-assets/js/scripts/forms/checkbox-radio.js')}}"></script>
    <script>
        $(document).ready(function () {

            //$("#my_cb").on("ifChanged", hide_row_metod);
            $('.sec-switch').on('ifChanged', function (e) {
                e.preventDefault();
                var id = $(this).data('id');
                if ($(this).prop("checked")) {
                    var status = 1;
                } else {
                    var status = 0;
                }

                var url = '<?php echo url('change_layer_status');?>';
                var data = {
                    'id': $(this).data('id'),
                    'status': status
                }

                var post = ajax_post(url, data, 'POST');
                post.done(function (response) {
                    notification(response.message, response.type, '');
                });
            });

            $('.suspend').on('click', function (e) {
                e.preventDefault();
                $('#modalSlideUpSmall').modal('show');

                $('.md-message').html('Are you sure you want to suspend the application?');
                var delete_url = '<?php echo url('suspend');?>';
                //alert(delete_url);
                //alert(delete_url);
                $('.confirm').data('delete_url', delete_url);
                $('.confirm').data('method', 'GET');
            });
        });
    </script>

@endsection