@extends('layouts.app')

@section('styles')
    <link rel="stylesheet" type="text/css"
          href="{{ asset('modern/app-assets/vendors/css/forms/selects/select2.min.css')}}">
    <style>

    </style>
@endsection

@section('content')

    <div class="row">
        <div class="col-lg-12">

            <div class="card">
                <div class="card-header separator">
                    <h4 class="card-title" id="heading-buttons1">Edit Users</h4>
                    <a class="heading-elements-toggle"><i class="la la-ellipsis-v font-medium-3"></i></a>
                    <div class="heading-elements">

                    </div>
                </div>
                <div class="card-content">
                    <div class="card-body">
                        <form role="form" action="{{url('user/'.$rows->id)}}" method="POST"
                              class="add form-validations">

                            <div class="row">
                                <div class="col-md-4">
                                    <div class="form-group form-group-style required">
                                        <label>Name <span class="red">*</span></label>
                                        <input type="text" class="form-control validate[required]" name="name"
                                               value="{{$rows->name}}"
                                        >
                                    </div>
                                </div>

                                <div class="col-md-4">
                                    <div class="form-group form-group-style required">
                                        <label>User Name <span class="red">*</span></label>
                                        <input type="text" class="form-control validate[required, custom[email]]"
                                               name="email" id="email"
                                               value="{{$rows->email}}"
                                               placeholder="jeny@pragicts.com">
                                    </div>
                                </div>

                                <div class="col-md-4">
                                    <div class="form-group form-group-style form-group-style-select2 required dis">
                                        <label>User Role <span class="red">*</span></label>
                                        <select class="select2 form-control full-w validate[required]"
                                                name="role" disabled="">
                                            <option value="">Please select</option>
                                            @foreach($roles as $val)
                                                <option
                                                    <?php echo $rows->roles()->pluck('id')->implode('') == $val->id ? "selected" : "";?> value="{{$val->name}}">{{$val->name}}</option>
                                            @endforeach
                                        </select>
                                    </div>
                                </div>
                            </div>

                            <div class="row">
                                <div class="col-md-4">
                                    <div class="form-group form-group-style required">
                                        <label>Phone Number <span class="red">*</span></label>
                                        <input type="number" class="form-control validate[required]"
                                               name="phone" id="phone" value="{{$rows->phone}}">
                                    </div>
                                </div>
                                <div class="col-md-4">
                                    <div class="form-group form-group-style form-group-style-select2 required">
                                        <label>Status <span class="red">*</span></label>
                                        <select class="select2 form-control full-w validate[required]"
                                                name="status">
                                            <option <?php echo $rows->status == 1 ? "selected" : "";?> value="1">Active
                                            </option>
                                            <option <?php echo $rows->status == 0 ? "selected" : "";?> value="0">
                                                Deactivate
                                            </option>
                                        </select>
                                    </div>
                                </div>
                                <div class="col-md-4">
                                    <div class="form-group form-group-style required dis">
                                        <label>Pin Number</label>
                                        <input type="text" class="form-control" disabled=""
                                               value="{{$rows->pin_number}}">
                                    </div>
                                </div>
                            </div>
                            <div class="row">
                                <div class="col-md-6">
                                    <div class="form-group form-group-style">
                                        <label>Mac Address</label>
                                        <input type="text" class="form-control"
                                               name="mac_address"
                                               value="{{$rows->mac_address}}"
                                        >
                                    </div>
                                </div>
                                <div class="col-md-6">
                                    <div class="form-group form-group-style">
                                        <label>Ip Address</label>
                                        <input type="text" class="form-control validate[custom[ipv4]]"
                                               value="{{$rows->ip_address}}"
                                               name="ip_address">
                                    </div>
                                </div>
                            </div>

                            <div class="row">
                                <div class="col-md-6">
                                    <div class="form-group form-group-style">
                                        <label>Profile Image
                                            <small>(70px * 70px)</small>
                                        </label>
                                        <input type="file" class="form-control" name="image_url">
                                    </div>
                                </div>
                                <div class="col-md-6">
                                    @if($rows->image_url != "")
                                        <div class="user-prof">
                                            <img alt="Profile Image" class="img-thumbnail"
                                                 src="{{asset('admin/uploads/user_profile/'.$rows->image_url)}}">
                                        </div>
                                        <div class="checkbox check-success">
                                            <input name="remove_image" type="checkbox" value="{{$rows->id}}"
                                                   id="checkbox{{$rows->id}}" class="remove_image">
                                            <label for="checkbox{{$rows->id}}">Remove Profile Image</label>
                                        </div>
                                    @endif
                                </div>
                            </div>

                            <div class="clearfix">
                                <div class="float-right">
                                    <button class="btn btn-warning btn-min-width btn-cons cancel-btn" type="button"
                                            data-redirect_url="{{url('user')}}">
                                        <i class="ft-x"></i>Cancel
                                    </button>
                                    <button class="btn btn-info btn-min-width btn-cons image-form-save" type="button"
                                            data-formname="add"
                                            data-posttype="POST">
                                        <i class="la la-check-square-o"></i> Save
                                    </button>
                                </div>
                            </div>

                        </form>
                    </div>
                </div>
            </div>

        </div>
    </div>

@endsection

@section('script')
    <script src="{{ asset('modern/app-assets/vendors/js/forms/select/select2.full.min.js')}}"></script>
    <script>
        $(document).ready(function () {
            $(".select2").select2();

            $('#email').on('blur', function (evt) {
                var checkExistUrl = '<?php echo url('validateUserName');?>';
                checkExistUrl = checkExistUrl + '/?edit=' + '<?php echo $rows->id;?>';
                var houseNumber = $(this).val();
                checkExist(checkExistUrl, 'email', $(this));

            });
        });
    </script>

@endsection