@extends('layouts.app')
@section('styles')
    <link rel="stylesheet" type="text/css"
          href="{{asset('modern/app-assets/vendors/css/tables/datatable/datatables.min.css')}}">
    <link rel="stylesheet" type="text/css"
          href="{{asset('modern/app-assets/vendors/css/tables/extensions/responsive.dataTables.min.css')}}">
    <link rel="stylesheet" type="text/css" href="{{asset('modern/app-assets/css/plugins/animate/animate.css')}}">
@endsection
@section('content')
    <style>
        .table th, .table td {
            padding: .75rem 1rem !important;
        }
    </style>

    <div class="row">
        <div class="col-lg-12">

            <div class="card">
                <div class="card-header ">
                    <h4 class="card-title" id="heading-buttons1">Manage Users</h4>
                    <a class="heading-elements-toggle"><i class="la la-ellipsis-v font-medium-3"></i></a>
                    <div class="heading-elements">
                        <a href="{{url('user/create')}}"
                           class="btn btn-info btn-min-width btn-glow btn-cons pull-right">Add</a>

                    </div>
                </div>

                <div class="card-content">
                    <div class="card-body user-list">
                        <div class="table-responsive">
                            <table class="table table-striped table-bordered ajax-sourced " id="posts-table" style="width:100%">
                                <thead>
                                <tr>
                                    <th style="width: 5%;">#</th>
                                    <th style="width: 10%;">Name</th>
                                    <th>User Name</th>
                                    <th style="width: 50px !important;">Pin</th>
                                    <th>Role</th>
                                    <th>Status</th>
                                    <th style="width: 50px !important;">Is Login</th>
                                    <th class="nosort"  style="width: 100px!important;">Action</th>
                                </tr>
                                </thead>
                                <tbody>
                                </tbody>
                            </table>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>

@endsection

@section('script')
    <script src="{{ asset('modern/app-assets/vendors/js/tables/datatable/datatables.min.js')}}"></script>

    <script>
        $(document).ready(function () {
            $('#posts-table').DataTable({
                processing: true,
                serverSide: true,
                ajax: '<?php echo url('getUserData')?>',
                columns: [
                    {data: 'DT_Row_Index', name: 'DT_Row_Index', orderable: false, searchable: false, "width": "6%"},
                    {data: 'name', name: 'name', "width": "12%"},
                    {data: 'email', name: 'email', "width": "30%"},
                    {data: 'pin_number', name: 'pin_number', "width": "6%"},
                    {data: 'role', name: 'role', "width": "12%"},
                    {data: 'status', name: 'status', "width": "5%"},
                    {data: 'is_logged_in', name: 'is_logged_in', "width": "5%"},
                    {data: 'action', name: 'action', orderable: false, searchable: false, "width": "13%"}
                ],
                autoWidth: false,
            });
        });
    </script>

@endsection