<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

//Route::get('/', function () {
//    return view('welcome');
//});
Route::get('m_construction', 'Admin\Security\Permission\PermissionController@downSite');

Route::group(['middleware' => ['maintenance']], function () {
    Route::get('login', 'Admin\Security\Auth\LoginController@showLoginForm')->name('login');
    Route::post('login', 'Admin\Security\Auth\LoginController@login');
    Route::post('login_step_two', 'Admin\Security\Auth\LoginController@loginStepTwo');
    Route::post('login_step_three', 'Admin\Security\Auth\LoginController@loginStepThree');
    Route::get('changePassword', 'Admin\Security\Auth\LoginController@changePassword');
    Route::post('reset_password', 'Admin\Security\Auth\LoginController@resetPassword');

    Route::get('get_email', 'Admin\Security\Auth\LoginController@getEmail');
    Route::post('sendResetEmail', 'Admin\Security\Auth\LoginController@sendResetEmail');

    Route::get('/logout', 'Auth\LoginController@logout')->name('logout');

    Route::group(['middleware' => 'auth'], function () {
        Route::get('/', 'HomeController@index')->name('home');
    });

    Route::group(['namespace' => 'Admin', 'middleware' => 'auth'], function () {

        Route::get('create_invoice', 'Invoice\InvoiceController@create');

        Route::get('test_in', 'Invoice\InvoiceController@test');
        Route::get('getInvoiceData', 'Invoice\InvoiceController@getInvoiceData');
        Route::get('invoices/{id}/edit', 'Invoice\InvoiceController@edit');
        
        Route::post('invoices/{id}', 'Invoice\InvoiceController@update');
        Route::delete('delete_invoice/{id}', 'Invoice\InvoiceController@destroy');
        Route::get('invoice', 'Invoice\InvoiceController@index');
        Route::post('sendInvoice', 'Invoice\InvoiceController@sendInvoice');
        Route::post('create_invoice_only', 'Invoice\InvoiceController@saveInvoice');
        Route::post('send_again', 'Invoice\InvoiceController@sendAgain');
        Route::get('getPaymentResponse', 'Invoice\InvoiceController@getPaymentResponse');
        
        Route::get('invoice_list', 'Report\ReportController@index');
        Route::get('rp_getInvoiceData', 'Report\ReportController@getInvoiceData');
    });
    
Route::get('notify', 'Admin\Invoice\InvoiceController@notify');

    Route::group(['namespace' => 'Admin\Security', 'middleware' => 'auth'], function () {
        Route::resource('user', 'User\UserController');
        Route::post('user/{id}', 'User\UserController@update');
        Route::get('validateUserName', 'User\UserController@validateUserName');
        Route::get('getUserData', 'User\UserController@getUserData');

        Route::get('noPermission', 'Auth\LoginController@noPermission');

        Route::get('main_settings', 'Setting\SettingController@mainSettings');
        Route::post('change_layer_status', 'Setting\SettingController@changeLayerStatus');
        Route::post('change_layer_status', 'Setting\SettingController@changeLayerStatus');
        Route::post('price_quote', 'Setting\SettingController@settingInfo');

        Route::get('role_permission', 'Permission\PermissionController@rolePermission');
        Route::get('create_role_permission', 'Permission\PermissionController@createRolePermission');
        Route::post('create_role_permission', 'Permission\PermissionController@storeRolePermission');
        Route::get('roles/{id}/edit', 'Permission\PermissionController@editRolePermission');
        Route::post('update/{id}', 'Permission\PermissionController@updateRolePermission');
        Route::delete('delete/{id}', 'Permission\PermissionController@destroyRolePermission');

        Route::get('suspend', 'Permission\PermissionController@suspend');
        Route::post('checkValid', 'Permission\PermissionController@checkValid');


    });

    Route::group(['namespace' => 'Admin', 'middleware' => 'auth'], function () {
        Route::get('get_token', 'Api\DataMigrationController@getToken');
        Route::post('send_item', 'Api\DataMigrationController@sendItem');
        Route::get('get_item_from_sell', 'Api\DataMigrationController@getItem');
        Route::get('get_order', 'Api\DataMigrationController@getOrder');
        Route::get('get_order', 'Api\DataMigrationController@getOrder');
    });

    Route::get('land_pay', 'Admin\Invoice\InvoiceController@LandPay');
    Route::post('sendPay', 'Admin\Invoice\InvoiceController@sendPay');
    Route::get('testCall', 'Admin\Invoice\InvoiceController@testCall');

    Route::get('/clear-cache', function () {
        \Illuminate\Support\Facades\Artisan::call('cache:clear');
        \Illuminate\Support\Facades\Artisan::call('view:clear');
        \Illuminate\Support\Facades\Artisan::call('route:clear');
        \Illuminate\Support\Facades\Artisan::call('config:clear');
        echo 'cache clear';
    });


});
